Index: LMDZ6/branches/Amaury_dev/libf/phylmd/rrtm/suecrad.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/rrtm/suecrad.F90	(revision 5153)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/rrtm/suecrad.F90	(revision 5154)
@@ -2,213 +2,214 @@
 ! $Id: suecrad.F90 4251 2022-09-20 00:22:43Z fhourdin $
 !
-SUBROUTINE SUECRAD (KULOUT, KLEV, PETAH )
-
-!**** *SUECRAD*   - INITIALIZE COMMONS YOERxx CONTROLLING RADIATION
-
-!     PURPOSE.
-!     --------
-!           INITIALIZE YOERAD, THE COMMON THAT CONTROLS THE
-!           RADIATION OF THE MODEL, AND YOERDU THAT INCLUDES
-!           ADJUSTABLE PARAMETERS FOR RADIATION COMPUTATIONS
-
-!**   INTERFACE.
-!     ----------
-!        CALL *SUECRAD* FROM *SUPHEC*
-!              -------        ------
-
-!        EXPLICIT ARGUMENTS :
-!        --------------------
-!        NONE
-
-!        IMPLICIT ARGUMENTS :
-!        --------------------
-!        COMMONS YOERAD, YOERDU
-
-!     METHOD.
-!     -------
-!        SEE DOCUMENTATION
-
-!     EXTERNALS.
-!     ----------
-!        SUAER, SUAERH, SUAERV, SULW, SUSW, SUOCST, SUSAT
-!        SUAERL, SUAERSN, SUSRTAER, SRTM_INIT, SUSRTCOP
-
-!     REFERENCE.
-!     ----------
-!        ECMWF Research Department documentation of the IFS
-
-!     AUTHOR.
-!     -------
-!        JEAN-JACQUES MORCRETTE  *ECMWF*
-
-!     MODIFICATIONS.
-!     --------------
-!        ORIGINAL : 88-12-15
-!        P.COURTIER AND M.HAMRUD NAME SURAD ALREADY USED
-!        Modified 93-11-15 by Ph. Dandin : FMR scheme with MF
-!        Modified 95-12 by PhD : Cloud overlapping hypothesis for FMR
-!        980317 JJMorcrette clean-up (NRAD, NFLUX)
-!        000118 JJMorcrette variable concentr. uniformly mixed gases
-!        990525 JJMorcrette GISS volcanic and new tropospheric aerosols
-!        990831 JJMorcrette RRTM
-!        R. El Khatib 01-02-02 proper initialization of NFRRC moved in SUCFU
-!        010129 JJMorcrette clean-up LERAD1H, NLNGR1H
-!        011105 GMozdzynski support new radiation grid
-!        011005 JJMorcrette CCN --> Re Water clouds
-!        R. El Khatib 01-02-02 LRRTM=lecmwf by default
-!        020909 GMozdzynski support NRADRES to specify radiation grid
-!        021001 GMozdzynski support on-demand radiation communications
-!        030422 GMozdzynski automatic min-halo
-!        030501 JJMorcrette new radiation grid on, new aerosols on (default)
-!        030513 JJMorcrette progn. O3 / radiation interactions off (default)
-!        M.Hamrud      01-Oct-2003 CY28 Cleaning
-!        050315 JJMorcrette prog.aerosols v1
-!        041214 JJMorcrette SRTM
-!        050111 JJMorcrette new cloud optical properties
-!        050415 GMozdzynski Reduced halo support for radiation interpolation
-!        051004 JJMorcrette UV surface radiation processor
-!        051220 JJMorcrette SRTM112g+LWSCAT+UVprocessor+(bgfx:swclr, radaca)
-!        060510 JJMorcrette MODIS albedo (UVis, NIR)x(parallel+diffuse)
-!        060510 JJMorcrette MODIS albedo (UVis, NIR)x(parallel+diffuse)
-!        JJMorcrette 20060721 PP of clear-sky PAR and TOA incident solar radiation
-!        060625 JJMorcrette MODIS albedo (UVis, NIR)x(parallel+diffuse)
-!        060726 JJMorcrette McICA default operational configuration
-!     ------------------------------------------------------------------
-
-USE PARKIND1  ,ONLY : JPIM     ,JPRB
-USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
-
-USE PARDIM   , ONLY : JPMXGL
-USE PARRRTM  , ONLY : JPLAY
-USE PARSRTM  , ONLY : JPGPT
-USE YOMCT0   , ONLY : LOUTPUT  ,NPRINTLEV,LALLOPR,&
- & NPROC    ,N_REGIONS_NS  ,N_REGIONS_EW
-USE YOMDIM   , ONLY : NDLON    ,NSMAX    ,NDGENL    ,&
- & NDGSAL   ,NDGLG    ,NDGSAG   ,NDGENG   ,NDSUR1    ,&
- & NDLSUR   ,NDGSUR   ,NGPBLKS  ,NFLEVG   ,NPROMA  
-USE YOMCT0B  , ONLY : LECMWF
-USE YOMDYN   , ONLY : TSTEP
-! Ce qui concerne NULRAD commente par MPL le 15.04.09
-!USE YOMLUN   , ONLY : NULNAM   ,NULRAD   ,NULOUT
-USE YOMLUN   , ONLY : NULRAD   ,NULOUT
-USE YOMCST   , ONLY : RDAY     ,RG       ,RCPD     ,RPI     ,RI0
-USE YOMPHY   , ONLY : LMPHYS, LRAYFM   ,LRAYFM15
-USE YOEPHY   , ONLY : LEPHYS   ,LERADI, LE4ALB
-USE YOERDI   , ONLY : RCCO2, RCCH4, RCN2O, RCCFC11, RCCFC12, RSOLINC
-USE YOERAD   , ONLY : NAER     , NOZOCL   ,&
- & NRADFR   ,NRADPFR  ,NRADPLA  ,NRINT    ,&
- & NRADNFR  ,NRADSFR  ,NOVLP    ,NRPROMA  ,&
-!& NLW      ,NSW      ,NTSW     ,NCSRADF  ,&
-! NSW mis dans .def MPL 20140211
- & NLW      ,NTSW     ,NCSRADF  ,&
- & NMODE    ,NLNGR1H  ,NSWNL    ,NSWTL    ,NUV     ,&
- & LERAD1H  ,LERADHS  ,LEPO3RA  ,LRADLB   ,LONEWSW ,&
- & LCCNL    ,LCCNO    ,&
- & LECSRAD  ,LHVOLCA  ,LNEWAER  ,LRRTM    ,LSRTM   ,LDIFFC  ,&
- & NRADINT  ,NRADRES  ,CRTABLEDIR,CRTABLEFIL       ,&
- & NICEOPT  ,NLIQOPT  ,NRADIP   ,NRADLP   ,NINHOM  ,NLAYINH ,&
- & LRAYL    ,LOPTRPROMA,&
- & RCCNLND  ,RCCNSEA  ,RLWINHF  ,RSWINHF  ,RRe2De  ,&
- & RPERTOZ  ,NPERTOZ  ,NMCICA   ,&
- & LNOTROAER,NPERTAER ,LECO2VAR ,LHGHG    ,NHINCSOL,NSCEN ,&
- & LEDBUG
-USE YOERDU   , ONLY : NUAER    ,NTRAER   ,RCDAY    ,R10E     ,&
- & REPLOG   ,REPSC    ,REPSCO   ,REPSCQ   ,REPSCT   ,&
- & REPSCW   ,DIFF  
-USE YOEAERD  , ONLY : CVDAES   ,CVDAEL   ,CVDAEU   ,CVDAED   ,&
- & RCAEOPS  ,RCAEOPL  ,RCAEOPU  ,RCAEOPD  ,RCTRBGA  ,&
- & RCVOBGA  ,RCSTBGA  ,RCTRPT   ,RCAEADM  ,RCAEROS  ,            &
- & RCAEADK  
-USE YOE_UVRAD, ONLY : JUVLAM, LUVPROC, LUVTDEP, LUVDBG, NRADUV, NUVTIM, RUVLAM, RMUZUV
-
-USE YOMMP    , ONLY : MYPROC   ,NPRCIDS  ,LSPLIT   ,NAPSETS  ,&
- & NPTRFLOFF,NFRSTLOFF,MYFRSTACTLAT,MYLSTACTLAT,&
- & NSTA,NONL,NPTRFRSTLAT,NFRSTLAT,NLSTLAT ,&
- & MY_REGION_NS  ,MY_REGION_EW   ,NGLOBALINDEX ,&
- & NRISTA  ,NRIONL   ,NRIOFF    ,NRIEXT   ,NRICORE ,&
- & NRISENDPOS ,NRIRECVPOS ,NRISENDPTR ,NRIRECVPTR ,&
- & NARIB1  ,NRIPROCS ,NRIMPBUFSZ,NRISPT   ,NRIRPT ,&
- & NRICOMM ,&
- & NROSTA  ,NROONL   ,NROOFF    ,NROEXT   ,NROCORE ,&
- & NROSENDPOS ,NRORECVPOS ,NROSENDPTR ,NRORECVPTR ,&
- & NAROB1  ,NROPROCS ,NROMPBUFSZ,NROSPT   ,NRORPT ,&
- & NROCOMM
-USE YOMGC    , ONLY : GELAT    ,GELAM
-USE YOMLEG   , ONLY : RMU      ,RSQM2
-USE YOMSC2   , ONLY : &
- & NRIWIDEN  ,NRIWIDES  ,NRIWIDEW  ,NRIWIDEE,&
- & NROWIDEN  ,NROWIDES  ,NROWIDEW  ,NROWIDEE
-USE YOMGEM   , ONLY : NGPTOT   ,NGPTOTG   ,NGPTOTMX ,NLOENG
-USE YOMTAG   , ONLY : MTAGRAD
-USE YOMPRAD  , ONLY : LODBGRADI,LODBGRADL ,RADGRID  ,&
- & LRADONDEM  
-USE YOMRADF  , ONLY : EMTD     ,TRSW     ,EMTC      ,TRSC    ,&
- & SRSWD    ,SRLWD    ,SRSWDCS  ,SRLWDCS   ,SRSWDV  ,&
- & SRSWDUV  ,EDRO     ,SRSWPAR  ,SRSWUVB   ,SRSWPARC,  SRSWTINC,&
- & EMTU, RMOON
-! Commente par MPL 26.11.08 
-!USE YOPHNC   , ONLY :  LERADN2
-! MPLefebvre 6-11-08 commente tout ce qui concerne MPL_MODULE
-!USE MPL_MODULE  , ONLY :  MPL_BROADCAST, MPL_SEND, MPL_RECV
-USE YOM_YGFL , ONLY : YO3
-!!!!! A REVOIR (MPL) NDLNPR devrait etre initialise dans sudyn.F90
-USE YOMDYN   , ONLY : NDLNPR
-
-IMPLICIT NONE
-
-INTEGER(KIND=JPIM),INTENT(IN)    :: KLEV 
-INTEGER(KIND=JPIM),INTENT(IN)    :: KULOUT 
-REAL(KIND=JPRB)   ,INTENT(IN)    :: PETAH(KLEV+1) 
-!     LOCAL ARRAYS FOR THE PURPOSE OF READING NAMRGRI (RADIATION GRID)
-INTEGER(KIND=JPIM) :: NRGRI(JPMXGL)
-
-INTEGER(KIND=JPIM) :: IDGL,INBLW,IRADFR,IST1HR,ISTNHR,IDIR,IFIL
-INTEGER(KIND=JPIM) :: IRIRPTSUR,IRISPTSUR,IRIMAPLEN
-INTEGER(KIND=JPIM) :: JLON,JGLAT,JGL,JGLSUR,IDLSUR,IOFF,ILAT,ISTLON,IENDLON
-INTEGER(KIND=JPIM) :: IRORPTSUR,IROSPTSUR,IROMAPLEN
-INTEGER(KIND=JPIM) :: ILBRLATI,IUBRLATI,IGLGLO,IDUM,IU
-INTEGER(KIND=JPIM) :: J,JROC,IGPTOT
-INTEGER(KIND=JPIM) :: IROWIDEMAXN,IROWIDEMAXS,IROWIDEMAXW,IROWIDEMAXE
-INTEGER(KIND=JPIM) :: IRIWIDEMAXN,IRIWIDEMAXS,IRIWIDEMAXW,IRIWIDEMAXE
-INTEGER(KIND=JPIM) :: IARIB1MAX,IAROB1MAX
-INTEGER(KIND=JPIM) :: IWIDE(10)
-INTEGER(KIND=JPIM) :: ILATS_DIFF_F,ILATS_DIFF_C
-INTEGER(KIND=JPIM), PARAMETER :: JP_MIN_HALO=5
-INTEGER(KIND=JPIM) :: ISW,JUV,IDAYUV
-
-LOGICAL :: LLINEAR_GRID
-LOGICAL :: LLDEBUG,LLP
-
-REAL(KIND=JPRB) :: ZSTPHR, ZTSTEP, ZGEMU, ZLON, ZD1, ZD2, ZD3, ZD4, ZD5, ZD6
-REAL(KIND=JPRB) :: ZMINRADLAT,ZMAXRADLAT,ZMINRADLON,ZMAXRADLON
-REAL(KIND=JPRB) :: ZMINMDLLAT,ZMAXMDLLAT,ZMINMDLLON,ZMAXMDLLON
-REAL(KIND=JPRB) :: ZLAT
-!REAL(KIND=JPRB) :: RLATVOL, RLONVOL
-
-CHARACTER (LEN = 300) ::  CLFN
-INTEGER(KIND=JPIM), PARAMETER :: JPIOMASTER=1
-
-INTEGER(KIND=JPIM), ALLOCATABLE :: IRISENDPOS(:)
-INTEGER(KIND=JPIM), ALLOCATABLE :: IRIRECVPOS(:)
-INTEGER(KIND=JPIM), ALLOCATABLE :: IRISENDPTR(:)
-INTEGER(KIND=JPIM), ALLOCATABLE :: IRIRECVPTR(:)
-INTEGER(KIND=JPIM), ALLOCATABLE :: IRICOMM(:)
-INTEGER(KIND=JPIM), ALLOCATABLE :: IRIMAP(:,:)
-INTEGER(KIND=JPIM), ALLOCATABLE :: IROSENDPOS(:)
-INTEGER(KIND=JPIM), ALLOCATABLE :: IRORECVPOS(:)
-INTEGER(KIND=JPIM), ALLOCATABLE :: IROSENDPTR(:)
-INTEGER(KIND=JPIM), ALLOCATABLE :: IRORECVPTR(:)
-INTEGER(KIND=JPIM), ALLOCATABLE :: IROCOMM(:)
-INTEGER(KIND=JPIM), ALLOCATABLE :: IROMAP(:,:)
-INTEGER(KIND=JPIM), ALLOCATABLE :: IGLOBALINDEX(:)
-
-REAL(KIND=JPRB),ALLOCATABLE :: ZLATX(:)
-REAL(KIND=JPRB),ALLOCATABLE :: ZLONX(:)
-REAL(KIND=JPRB) :: ZHOOK_HANDLE
-
-INTERFACE
+SUBROUTINE SUECRAD (KULOUT, KLEV, PETAH)
+
+  !**** *SUECRAD*   - INITIALIZE COMMONS YOERxx CONTROLLING RADIATION
+
+  !     PURPOSE.
+  !     --------
+  !           INITIALIZE YOERAD, THE COMMON THAT CONTROLS THE
+  !           RADIATION OF THE MODEL, AND YOERDU THAT INCLUDES
+  !           ADJUSTABLE PARAMETERS FOR RADIATION COMPUTATIONS
+
+  !**   INTERFACE.
+  !     ----------
+  !        CALL *SUECRAD* FROM *SUPHEC*
+  !              -------        ------
+
+  !        EXPLICIT ARGUMENTS :
+  !        --------------------
+  !        NONE
+
+  !        IMPLICIT ARGUMENTS :
+  !        --------------------
+  !        COMMONS YOERAD, YOERDU
+
+  !     METHOD.
+  !     -------
+  !        SEE DOCUMENTATION
+
+  !     EXTERNALS.
+  !     ----------
+  !        SUAER, SUAERH, SUAERV, SULW, SUSW, SUOCST, SUSAT
+  !        SUAERL, SUAERSN, SUSRTAER, SRTM_INIT, SUSRTCOP
+
+  !     REFERENCE.
+  !     ----------
+  !        ECMWF Research Department documentation of the IFS
+
+  !     AUTHOR.
+  !     -------
+  !        JEAN-JACQUES MORCRETTE  *ECMWF*
+
+  !     MODIFICATIONS.
+  !     --------------
+  !        ORIGINAL : 88-12-15
+  !        P.COURTIER AND M.HAMRUD NAME SURAD ALREADY USED
+  !        Modified 93-11-15 by Ph. Dandin : FMR scheme with MF
+  !        Modified 95-12 by PhD : Cloud overlapping hypothesis for FMR
+  !        980317 JJMorcrette clean-up (NRAD, NFLUX)
+  !        000118 JJMorcrette variable concentr. uniformly mixed gases
+  !        990525 JJMorcrette GISS volcanic and new tropospheric aerosols
+  !        990831 JJMorcrette RRTM
+  !        R. El Khatib 01-02-02 proper initialization of NFRRC moved in SUCFU
+  !        010129 JJMorcrette clean-up LERAD1H, NLNGR1H
+  !        011105 GMozdzynski support new radiation grid
+  !        011005 JJMorcrette CCN --> Re Water clouds
+  !        R. El Khatib 01-02-02 LRRTM=lecmwf by default
+  !        020909 GMozdzynski support NRADRES to specify radiation grid
+  !        021001 GMozdzynski support on-demand radiation communications
+  !        030422 GMozdzynski automatic min-halo
+  !        030501 JJMorcrette new radiation grid on, new aerosols on (default)
+  !        030513 JJMorcrette progn. O3 / radiation interactions off (default)
+  !        M.Hamrud      01-Oct-2003 CY28 Cleaning
+  !        050315 JJMorcrette prog.aerosols v1
+  !        041214 JJMorcrette SRTM
+  !        050111 JJMorcrette new cloud optical properties
+  !        050415 GMozdzynski Reduced halo support for radiation interpolation
+  !        051004 JJMorcrette UV surface radiation processor
+  !        051220 JJMorcrette SRTM112g+LWSCAT+UVprocessor+(bgfx:swclr, radaca)
+  !        060510 JJMorcrette MODIS albedo (UVis, NIR)x(parallel+diffuse)
+  !        060510 JJMorcrette MODIS albedo (UVis, NIR)x(parallel+diffuse)
+  !        JJMorcrette 20060721 PP of clear-sky PAR and TOA incident solar radiation
+  !        060625 JJMorcrette MODIS albedo (UVis, NIR)x(parallel+diffuse)
+  !        060726 JJMorcrette McICA default operational configuration
+  !     ------------------------------------------------------------------
+
+  USE PARKIND1, ONLY: JPIM, JPRB
+  USE YOMHOOK, ONLY: LHOOK, DR_HOOK
+
+  USE PARDIM, ONLY: JPMXGL
+  USE PARRRTM, ONLY: JPLAY
+  USE PARSRTM, ONLY: JPGPT
+  USE YOMCT0, ONLY: LOUTPUT, NPRINTLEV, LALLOPR, &
+          & NPROC, N_REGIONS_NS, N_REGIONS_EW
+  USE YOMDIM, ONLY: NDLON, NSMAX, NDGENL, &
+          & NDGSAL, NDGLG, NDGSAG, NDGENG, NDSUR1, &
+          & NDLSUR, NDGSUR, NGPBLKS, NFLEVG, NPROMA
+  USE YOMCT0B, ONLY: LECMWF
+  USE YOMDYN, ONLY: TSTEP
+  ! Ce qui concerne NULRAD commente par MPL le 15.04.09
+  !USE YOMLUN   , ONLY : NULNAM   ,NULRAD   ,NULOUT
+  USE YOMLUN, ONLY: NULRAD, NULOUT
+  USE YOMCST, ONLY: RDAY, RG, RCPD, RPI, RI0
+  USE YOMPHY, ONLY: LMPHYS, LRAYFM, LRAYFM15
+  USE YOEPHY, ONLY: LEPHYS, LERADI, LE4ALB
+  USE YOERDI, ONLY: RCCO2, RCCH4, RCN2O, RCCFC11, RCCFC12, RSOLINC
+  USE YOERAD, ONLY: NAER, NOZOCL, &
+          & NRADFR, NRADPFR, NRADPLA, NRINT, &
+          & NRADNFR, NRADSFR, NOVLP, NRPROMA, &
+          !& NLW      ,NSW      ,NTSW     ,NCSRADF  ,&
+          ! NSW mis dans .def MPL 20140211
+          & NLW, NTSW, NCSRADF, &
+          & NMODE, NLNGR1H, NSWNL, NSWTL, NUV, &
+          & LERAD1H, LERADHS, LEPO3RA, LRADLB, LONEWSW, &
+          & LCCNL, LCCNO, &
+          & LECSRAD, LHVOLCA, LNEWAER, LRRTM, LSRTM, LDIFFC, &
+          & NRADINT, NRADRES, CRTABLEDIR, CRTABLEFIL, &
+          & NICEOPT, NLIQOPT, NRADIP, NRADLP, NINHOM, NLAYINH, &
+          & LRAYL, LOPTRPROMA, &
+          & RCCNLND, RCCNSEA, RLWINHF, RSWINHF, RRe2De, &
+          & RPERTOZ, NPERTOZ, NMCICA, &
+          & LNOTROAER, NPERTAER, LECO2VAR, LHGHG, NHINCSOL, NSCEN, &
+          & LEDBUG
+  USE YOERDU, ONLY: NUAER, NTRAER, RCDAY, R10E, &
+          & REPLOG, REPSC, REPSCO, REPSCQ, REPSCT, &
+          & REPSCW, DIFF
+  USE YOEAERD, ONLY: CVDAES, CVDAEL, CVDAEU, CVDAED, &
+          & RCAEOPS, RCAEOPL, RCAEOPU, RCAEOPD, RCTRBGA, &
+          & RCVOBGA, RCSTBGA, RCTRPT, RCAEADM, RCAEROS, &
+          & RCAEADK
+  USE YOE_UVRAD, ONLY: JUVLAM, LUVPROC, LUVTDEP, LUVDBG, NRADUV, NUVTIM, RUVLAM, RMUZUV
+
+  USE YOMMP, ONLY: MYPROC, NPRCIDS, LSPLIT, NAPSETS, &
+          & NPTRFLOFF, NFRSTLOFF, MYFRSTACTLAT, MYLSTACTLAT, &
+          & NSTA, NONL, NPTRFRSTLAT, NFRSTLAT, NLSTLAT, &
+          & MY_REGION_NS, MY_REGION_EW, NGLOBALINDEX, &
+          & NRISTA, NRIONL, NRIOFF, NRIEXT, NRICORE, &
+          & NRISENDPOS, NRIRECVPOS, NRISENDPTR, NRIRECVPTR, &
+          & NARIB1, NRIPROCS, NRIMPBUFSZ, NRISPT, NRIRPT, &
+          & NRICOMM, &
+          & NROSTA, NROONL, NROOFF, NROEXT, NROCORE, &
+          & NROSENDPOS, NRORECVPOS, NROSENDPTR, NRORECVPTR, &
+          & NAROB1, NROPROCS, NROMPBUFSZ, NROSPT, NRORPT, &
+          & NROCOMM
+  USE YOMGC, ONLY: GELAT, GELAM
+  USE YOMLEG, ONLY: RMU, RSQM2
+  USE YOMSC2, ONLY: &
+          & NRIWIDEN, NRIWIDES, NRIWIDEW, NRIWIDEE, &
+          & NROWIDEN, NROWIDES, NROWIDEW, NROWIDEE
+  USE YOMGEM, ONLY: NGPTOT, NGPTOTG, NGPTOTMX, NLOENG
+  USE YOMTAG, ONLY: MTAGRAD
+  USE YOMPRAD, ONLY: LODBGRADI, LODBGRADL, RADGRID, &
+          & LRADONDEM
+  USE YOMRADF, ONLY: EMTD, TRSW, EMTC, TRSC, &
+          & SRSWD, SRLWD, SRSWDCS, SRLWDCS, SRSWDV, &
+          & SRSWDUV, EDRO, SRSWPAR, SRSWUVB, SRSWPARC, SRSWTINC, &
+          & EMTU, RMOON
+  ! Commente par MPL 26.11.08
+  !USE YOPHNC   , ONLY :  LERADN2
+  ! MPLefebvre 6-11-08 commente tout ce qui concerne MPL_MODULE
+  !USE MPL_MODULE  , ONLY :  MPL_BROADCAST, MPL_SEND, MPL_RECV
+  USE YOM_YGFL, ONLY: YO3
+  !!!!! A REVOIR (MPL) NDLNPR devrait etre initialise dans sudyn.F90
+  USE YOMDYN, ONLY: NDLNPR
+  USE lmdz_clesphys
+
+  IMPLICIT NONE
+
+  INTEGER(KIND = JPIM), INTENT(IN) :: KLEV
+  INTEGER(KIND = JPIM), INTENT(IN) :: KULOUT
+  REAL(KIND = JPRB), INTENT(IN) :: PETAH(KLEV + 1)
+  !     LOCAL ARRAYS FOR THE PURPOSE OF READING NAMRGRI (RADIATION GRID)
+  INTEGER(KIND = JPIM) :: NRGRI(JPMXGL)
+
+  INTEGER(KIND = JPIM) :: IDGL, INBLW, IRADFR, IST1HR, ISTNHR, IDIR, IFIL
+  INTEGER(KIND = JPIM) :: IRIRPTSUR, IRISPTSUR, IRIMAPLEN
+  INTEGER(KIND = JPIM) :: JLON, JGLAT, JGL, JGLSUR, IDLSUR, IOFF, ILAT, ISTLON, IENDLON
+  INTEGER(KIND = JPIM) :: IRORPTSUR, IROSPTSUR, IROMAPLEN
+  INTEGER(KIND = JPIM) :: ILBRLATI, IUBRLATI, IGLGLO, IDUM, IU
+  INTEGER(KIND = JPIM) :: J, JROC, IGPTOT
+  INTEGER(KIND = JPIM) :: IROWIDEMAXN, IROWIDEMAXS, IROWIDEMAXW, IROWIDEMAXE
+  INTEGER(KIND = JPIM) :: IRIWIDEMAXN, IRIWIDEMAXS, IRIWIDEMAXW, IRIWIDEMAXE
+  INTEGER(KIND = JPIM) :: IARIB1MAX, IAROB1MAX
+  INTEGER(KIND = JPIM) :: IWIDE(10)
+  INTEGER(KIND = JPIM) :: ILATS_DIFF_F, ILATS_DIFF_C
+  INTEGER(KIND = JPIM), PARAMETER :: JP_MIN_HALO = 5
+  INTEGER(KIND = JPIM) :: ISW, JUV, IDAYUV
+
+  LOGICAL :: LLINEAR_GRID
+  LOGICAL :: LLDEBUG, LLP
+
+  REAL(KIND = JPRB) :: ZSTPHR, ZTSTEP, ZGEMU, ZLON, ZD1, ZD2, ZD3, ZD4, ZD5, ZD6
+  REAL(KIND = JPRB) :: ZMINRADLAT, ZMAXRADLAT, ZMINRADLON, ZMAXRADLON
+  REAL(KIND = JPRB) :: ZMINMDLLAT, ZMAXMDLLAT, ZMINMDLLON, ZMAXMDLLON
+  REAL(KIND = JPRB) :: ZLAT
+  !REAL(KIND=JPRB) :: RLATVOL, RLONVOL
+
+  CHARACTER (LEN = 300) :: CLFN
+  INTEGER(KIND = JPIM), PARAMETER :: JPIOMASTER = 1
+
+  INTEGER(KIND = JPIM), ALLOCATABLE :: IRISENDPOS(:)
+  INTEGER(KIND = JPIM), ALLOCATABLE :: IRIRECVPOS(:)
+  INTEGER(KIND = JPIM), ALLOCATABLE :: IRISENDPTR(:)
+  INTEGER(KIND = JPIM), ALLOCATABLE :: IRIRECVPTR(:)
+  INTEGER(KIND = JPIM), ALLOCATABLE :: IRICOMM(:)
+  INTEGER(KIND = JPIM), ALLOCATABLE :: IRIMAP(:, :)
+  INTEGER(KIND = JPIM), ALLOCATABLE :: IROSENDPOS(:)
+  INTEGER(KIND = JPIM), ALLOCATABLE :: IRORECVPOS(:)
+  INTEGER(KIND = JPIM), ALLOCATABLE :: IROSENDPTR(:)
+  INTEGER(KIND = JPIM), ALLOCATABLE :: IRORECVPTR(:)
+  INTEGER(KIND = JPIM), ALLOCATABLE :: IROCOMM(:)
+  INTEGER(KIND = JPIM), ALLOCATABLE :: IROMAP(:, :)
+  INTEGER(KIND = JPIM), ALLOCATABLE :: IGLOBALINDEX(:)
+
+  REAL(KIND = JPRB), ALLOCATABLE :: ZLATX(:)
+  REAL(KIND = JPRB), ALLOCATABLE :: ZLONX(:)
+  REAL(KIND = JPRB) :: ZHOOK_HANDLE
+
+  INTERFACE
 #include "setup_trans.h"
 #include "trans_inq.h"
-END INTERFACE
+  END INTERFACE
 
 #include "abor1.intfb.h"
